assert(RaidCooldowns, "RaidCooldowns not found!")
if (select(2, UnitClass("player"))) ~= "SHAMAN" then return end

local mod = RaidCooldowns:NewModule("Shaman", RaidCooldowns.ModuleBase, "AceEvent-3.0", "AceBucket-3.0")
mod.cooldowns = {
	[GetSpellInfo(2825)]  = { id = 2825,  cd = 600 },  -- Bloodlust
	[GetSpellInfo(16188)] = { id = 16188, cd = 180 },  -- Nature's Swiftness
	[GetSpellInfo(20608)] = { id = 20608, cd = 3600 }, -- Reincarnation; not actually picked up by UNIT_SPELLCAST_SUCCEEDED
}

--[[

	This module is almost entirely copied from oRA2_Participant, so thanks to that.
	
]]--

local ankhs   = nil
local resTime = nil

function mod:OnInitialize()
	self:Super("OnInitialize")
end

function mod:OnEnable()
	self:Super("OnEnable")
	
	self:RegisterEvent("PLAYER_ALIVE")
	self:RegisterBucketEvent("BAG_UPDATE", 0.5)
	
	ankhs = GetItemCount(17030)
	resTime = GetTime()
end

function mod:ScanTalents()
	-- Improved Reincarnation (Tab 3, Index 3)
	-- Reduce Reincarnation cooldown by Rank * 600
	local _, _, _, _, rank = GetTalentInfo(3, 3)
	self:CooldownModifier(20608, rank * 600)
end

function mod:PLAYER_ALIVE()
	resTime = GetTime()
end

function mod:BAG_UPDATE()
	if (GetTime() - (resTime or 0)) > 1 then
		return
	end

	local newankhs = GetItemCount(17030)
	if newankhs == (ankhs - 1) then
		local spellData = self.cooldowns[GetSpellInfo(20608)]
		
		self:Sync(20608, spellData.cd) -- Already modified by ScanTalents()
	end
	ankhs = newankhs
end